/*This shader draw anatomy and highlighting, and depth:
	Texture 0: Previous Layer Depth Texture.
	Texture 1: Anatomy Texture.
	Texture 2: Highlight Texture.
	Texture 3: Anatomy Depth Texture.
*/
$DepthPeel_UniformDefines$
uniform sampler2DRect anatomyTexture;
uniform sampler2DRect highlightTexture;
uniform sampler2DRect depthTexture;

void main()
{
	vec4 previousDepthVec, anatomyColor, highlightColor, resultColor, depthVector;
	float depth;

	//Get the current fragments depth from the passed in depth texture.
	depthVector = texture2DRect( depthTexture, gl_TexCoord[3].st );

	//Depth values are quantized.
	const vec4 bitShift = vec4( 1.0 / ( 256.0 * 256.0 * 256.0 ), 1.0 / ( 256.0 * 256.0 ), 1.0 / 256.0, 1.0 );
	depth = dot( depthVector, bitShift );
	
	if( depth >= 1.0 )
	{
		discard;
	}

	$DepthPeel_DepthTest$

	//Get anatomy and highlight color.
	anatomyColor = texture2DRect( anatomyTexture, gl_TexCoord[1].st );
	highlightColor = texture2DRect( highlightTexture, gl_TexCoord[2].st );
	
	//Blend the two colors based on the highlight opacity.
	resultColor = anatomyColor * ( 1.0 - highlightColor.a ) + highlightColor * highlightColor.a;
	resultColor.a = 1.0;

	gl_FragColor = resultColor;
	gl_FragDepth = depth;
}