/*This shader draws anatomy and highlighting:
	Texture 0: Anatomy Texture.
	Texture 1: Highlight Texture.
*/

uniform sampler2DRect anatomyTexture;
uniform sampler2DRect highlightTexture;

void main()
{
	vec4 anatomyColor, highlightColor, resultColor;

	//Get anatomy and highlight color.
	anatomyColor = texture2DRect( anatomyTexture, gl_TexCoord[0].st );
	highlightColor = texture2DRect( highlightTexture, gl_TexCoord[1].st );

	if( anatomyColor.a > 0.0 )
	{
		//Blend the two colors based on the highlight opacity.
		resultColor = anatomyColor * ( 1.0 - highlightColor.a ) + highlightColor * highlightColor.a;
		resultColor.a = 1.0;
	}
	else
	{
		discard;
	}
	
	gl_FragColor = resultColor;
}