/*This shader will draw depth:
	Texture 0: Depth Texture.
*/
uniform sampler2D depthTexture;

void main()
{
	vec4 depthVector = texture2D( depthTexture, gl_TexCoord[0].st );
	
	/*Depth values are quantized*/
	const vec4 bitShift = vec4( 1.0 / ( 256.0 * 256.0 * 256.0 ), 1.0 / ( 256.0 * 256.0 ), 1.0 / 256.0, 1.0 );
	gl_FragDepth = dot( depthVector, bitShift );	
}