/*This shader clears the alpha value for planes with a texture.
	Texture 0: Previous Layer Depth Texture.
	Texture 1: Color texture.
*/
$DepthPeel_UniformDefines$

uniform sampler2DRect colorTexture;

void main()
{
	vec4 color, resultColor;
	$DepthPeel_CurrentDepthVariable$

	$DepthPeel_DepthTest$

	//Get the texture color.
	color = texture2DRect( colorTexture, gl_TexCoord[1].st );
	
	if( color.r == 0.0 && color.g == 0.0 && color.b == 0.0 )
	{
		discard;
	}
	else
	{
		resultColor = vec4( color.r, color.g, color.b, gl_Color.a );
	}

	gl_FragColor = resultColor;
	gl_FragDepth = depth;
}